import greenfoot.*;  
import java.util.List;
public class Bullet extends Projectiles
{
       private int direction, speed;
       int frame = 0;
       GreenfootImage bullet1 = new GreenfootImage ("bullet.png");
       GreenfootImage bullet2 = new GreenfootImage ("bullet2.png");
       
       public Bullet(int dir)
       {
           direction = dir;
           speed = 15;
       }
       
       public void act()
       {
          
           
           setRotation(direction);
           
           move(speed);
           
           hitDetection();
           
           animate();           
       }
              
       public void hitDetection()
       {
           Actor m = getOneIntersectingObject(Matty.class); 
           Actor g = getOneIntersectingObject(Goomba.class); 

             if (atWorldEdge()== true)
            {
                getWorld().removeObject(this);
            }
            
            else if (canLeft()==false)
            {
                getWorld().removeObject(this);
            }
            
            else if (canRight()==false)
            {
                getWorld().removeObject(this);
            }
           
            else if(m != null)  
            {  
                getWorld().removeObject(m);   
                getWorld().removeObject(this);
            }  
            
            else if (g != null)
            {
                getWorld().removeObject(g);   
                getWorld().removeObject(this);
            }
           
       }
       
       public boolean canLeft()
       {
           boolean moveLeft = true;
        
           int imageWidth  = getImage().getWidth();
           int imageHeight = getImage().getHeight();
        
           if (getOneObjectAtOffset(imageWidth / -2 , imageHeight / -2, Platform.class) !=null ||   
               getOneObjectAtOffset(imageWidth / -2 , imageHeight / 2 - 1, Platform.class) !=null)     
        
           {
               moveLeft = false;
           }
        
           return moveLeft;
       }
       
           public boolean canRight()      // checking if Cpt Falcão can go right
       {
           boolean moveRight = true;
        
           int imageWidth = getImage().getWidth();
           int imageHeight = getImage().getHeight();
     
           if (getOneObjectAtOffset(imageWidth / 2 , imageHeight / -2, Platform.class) !=null ||     
           getOneObjectAtOffset(imageWidth / 2 , imageHeight / 2 - 1, Platform.class) !=null)       
        
           {
               moveRight = false;
           }
        
           return moveRight;
       }
       
       public boolean atWorldEdge()
       {
       
          if(getX() < 10 || getX() > getWorld().getWidth() - 10)
           return true;
        
          if(getY() < 10 || getY() > getWorld().getHeight() - 10)
           return true;
          else
           return false;
       }
              
       public void animate()
       {
            if(frame == 5)
           {
               setImage(bullet2);           
            }
         
            else if(frame == 10)
           {
                setImage(bullet1); 
                frame = 0;
                return;
           }
       
           frame ++;
        }
}
