import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Player Character
 * Alpha 0.1
 */
public class Capitão_Falcão extends players
{
    private  int gravity = 20;
    private  int step = 3;//how fast Cpt Falcão runs
    private  int velocity = 0;
       

    
    public   int pause = 20;
    
    GreenfootSound shootSound = new GreenfootSound ("shoot.mp3");
    
    GreenfootImage run1r = new GreenfootImage ("0.png");
    GreenfootImage run2r = new GreenfootImage ("2.png");
    GreenfootImage run3r = new GreenfootImage ("1.png");
    
    GreenfootImage run1l = new GreenfootImage ("0alt2.png");
    GreenfootImage run2l = new GreenfootImage ("2alt2.png");
    GreenfootImage run3l = new GreenfootImage ("1alt2.png");
    
    private int framer    = 1;
    private int framel    = 1;
    private int frameIdle = 1;
    private int direction = getRotation();
    
        public Capitão_Falcão()
    {
        velocity = 0;
        
    }
    
        public void act() 
    {           
       if(pause>0)
        {
            pause--;  //delay for shooting, so that its not a machinegun
        }
              
       if (Greenfoot.isKeyDown("up") && isOnSolidGround() )
        {
            jump();         // jumping
        }
        
       
        
       animateJump();
       
       animateIdle();
             
       direction = getRotation();
        
       move();         // left & right movement
                 
       fall();         // accelerated fall
       
       Shoot();        // shooting (duh...)
       
       cheats();
       

    }
    
        public boolean move()
    { 
        int y = getY();
        int x = getX();
        
        if (1 == 1)
        {
            if(Greenfoot.isKeyDown("left") && canMoveLeft())
                {   
                    x-=step ; setRotation (180);
                    animateLeft(); 
                    
                    if(Greenfoot.isKeyDown("control"))
                    {
                        step = 6;
                    }
                    else
                    {
                        step = 4;
                    }

                }
          
            if(Greenfoot.isKeyDown("right")&& canMoveRight())
                {
                    x+=step; setRotation(0); 
                    animateRight();     
                    
                    if(Greenfoot.isKeyDown("control"))
                    {
                        step = 6;
                    }
                    else
                    {
                        step = 4;
                    }

                }
                
                setLocation(x, y);
                return true;
        }
       
        return false;
 
    }
        
    public void animateIdle()
    {
        if(/*move() == false && isOnSolidGround() ||*/ !Greenfoot.isKeyDown("right") && !Greenfoot.isKeyDown("left") && isOnSolidGround())
        {
            if(direction == 0)
            {   setRotation(0);
                setImage("idle.png");
               
            }
            else
            {
                setRotation(180);
                setImage("idleAlt.png");
            }
        }      
    }
    
        public void animateRight() //walking animations for going right
    {
            if(isOnSolidGround())
        {
               if(framer <= 5 )
               {
                   setImage(run1r);              
               }
                else if(framer <= 9 && framer!=5 )
                {
                    setImage(run2r);
                }
                
                else if(framer <= 13 )
                {
                    setImage(run3r);
                    framer = 1;
                    return;
                }
                
               framer ++;
            }
    }
    
        public void animateLeft() //walking animations for going left
    {
            if(isOnSolidGround())
        {
               if(framel <= 5 )
               {
                    setImage(run1l);           
               }
                else if(framel <= 9 && framel!=5 )
                {
                    setImage(run2l); 
                }
                
                else if(framel <= 13 )
                {
                    setImage(run3l); 
                    framel = 1;
                    return;
                }
               
               framel ++;
        }
    }
    
    public void animateJump()
    {
    
       if(!isOnSolidGround() && direction == 180 ) //making sure that the sprite for falling/jumping is the correct one
        {
                setImage("4alt2.png");
            
        } 
        
       if(!isOnSolidGround() && direction == 0 )   //making sure that the sprite for falling/jumping is the correct one
        {
            
                setImage("4.png"); 
            
        }
    }

        public void fall() //this method lets you fall, if not on a platform
    {
        setLocation(getX(), getY() + velocity);
        
        if(isOnSolidGround())
       {
            velocity = 0;
        while (isOnSolidGround())
        {
                setLocation(getX(), getY() -1);
        }
                setLocation(getX(), getY () +1);       
       }
        
        else if (velocity < 0 && didBumpHead())
        { 
            velocity = 0;
        while(didBumpHead())
        {
                 setLocation(getX(),getY() + 1);
        }
        
       }    
        else
        {
            velocity += (int)gravity/10;
        }
    }
    
        public void jump() //jumnping is basically falling upwards/reversed
    {
        velocity = -gravity - 2;
    }
    
        public boolean isOnSolidGround()    // checking if there is something under Cpt Falcão's feet (anti-flying mechanism)
    {
        boolean isOnGround = false;
     
        if (getY()> getWorld().getHeight() - 50) 
            {
                isOnGround = true;
            }
        
        int imageWidth = getImage().getWidth();
        int imageHeight = getImage().getHeight();
         
        if (getOneObjectAtOffset(imageWidth / -2, imageHeight + 1 / 2, Platform.class) !=null ||    // checking bottom left corner and 
            getOneObjectAtOffset(imageWidth /  2, imageHeight + 1 / 2, Platform.class) !=null)       // bottom right corners of Cpt Falcão's Hitbox
            {
                isOnGround = true;
            }
         
        return isOnGround;
    }
    
        public boolean didBumpHead()        // checking if Cpt Falcão hit his head, so that he falls down if he did
    {
        boolean bumpedHead = false;
        
        int imageWidth = getImage().getWidth();
        int imageHeight = getImage().getHeight();
     
        if (getOneObjectAtOffset(imageWidth / -2, imageHeight / -2, Platform.class) !=null ||              // checking top left and top right corners of Cpt Falcão's Hitbox
            getOneObjectAtOffset(imageWidth / 2, imageHeight / -2, Platform.class) !=null)                 // top right corners of Cpt Falcão's Hitbox
        
         {
             bumpedHead = true;
         }
        
        return bumpedHead;
    }
    
        public boolean canMoveLeft()        // checking if Cpt Falcão can go left
    {
        boolean canLeft = true;
        
        int imageWidth = getImage().getWidth();
        int imageHeight = getImage().getHeight();
     
        if (getOneObjectAtOffset(imageWidth / -2 - step, imageHeight / -2, Platform.class) !=null ||    //checking top left and 
         getOneObjectAtOffset(imageWidth / -2 - step, imageHeight / 2 - 1, Platform.class) !=null)      // bottom left corners of Cpt Falcão's Hitbox
        
         {
             canLeft = false;
        }
        
        return canLeft;
    }
   
        public boolean canMoveRight()      // checking if Cpt Falcão can go right
    {
        boolean canRight = true;
        
        int imageWidth = getImage().getWidth();
        int imageHeight = getImage().getHeight();
     
        if (getOneObjectAtOffset(imageWidth / 2 + step, imageHeight / -2, Platform.class) !=null ||     // checking top right and 
         getOneObjectAtOffset(imageWidth / 2 + step, imageHeight / 2 - 1, Platform.class) !=null)       // bottom right corners of Cpt Falcão's Hitbox
        
         {
             canRight = false;
         }
        
        return canRight;
    }
        
        public void Shoot() //adds a new bullet to the world, moving in the same direction that Cpt Falcão is looking
    {
        if(Greenfoot.isKeyDown("space") && pause == 0 )
        {
            getWorld().addObject(new Bullet(getRotation()), getX(), getY());
            shootSound.play();
            pause = pause + 45;
        }
    }
    
    public void cheats()
    {
        if (Greenfoot.isKeyDown("escape"))
        {
            Greenfoot.setWorld(new CheatLand());
        }
    }
}